%saccade to next target
function [new_center, saliency_map, sorted_map] = saccade(saliency_map, center, radius, sorted_map)
deterministic = false; %false means treat saliency map as a probability distribution
IOR = false; %do not use inhibition of return (IOR)
if deterministic
    IOR = true;
end
if isempty(saliency_map)
    error('Saliency map is empty!');
end
initial_map = saliency_map;
saliency_map = saliency_map(radius+1:end-radius, radius+1:end-radius);

if ~deterministic
    if isempty(sorted_map) || IOR
        saliency_map = double(saliency_map);
        saliency_map = saliency_map ./ sum(saliency_map(:));
        [s_vals, s_indices] = sort(saliency_map(:), 1, 'descend');

        sorted_map.s_vals = cumsum(s_vals);
        sorted_map.s_indices = s_indices;
    end
    s_vals = sorted_map.s_vals;
    s_indices = sorted_map.s_indices;
    
    
    r = rand(1);
    ndx = s_indices(find(r <= s_vals, 1, 'first')); 
    [y_ndx, x_ndx] = ind2sub([size(saliency_map, 1), size(saliency_map, 2)], ndx);    
    
    y_ndx = y_ndx + radius;
    x_ndx = x_ndx + radius;
    
    new_center = [y_ndx, x_ndx];
end
saliency_map = initial_map;
if IOR
    [X_Grid, Y_Grid] = meshgrid(single(1:size(saliency_map, 2)), single(1:size(saliency_map, 1)));
    ior_var = 3;
    G = 1 - .5*exp(-.5 * ( ((Y_Grid - y_ndx) / ior_var) .^ 2 + ((X_Grid - x_ndx) / ior_var) .^ 2));
    saliency_map = saliency_map .* G;
end

